#include <M5Stack.h>
#include <Wire.h>
#include <WiFi.h>                    // Wi-Fi機能を利用するために必要
#include <WiFiUdp.h>
#define SSID "**********"                     // 無線LANアクセスポイントのSSID
#define PASS "**********"                     // パスワード
#define R_PORT 9000                           // 受信ポート番号
WiFiUDP udp;                                // UDP通信用のインスタンスを定義
String lip;
String msg[9]={"","","","","","","","",""};
int lmsg=9;
int lptr=0;

void drawLcd() {
  M5.Lcd.clear();
  M5.Lcd.setTextSize(2);
  M5.Lcd.setTextColor(TFT_GREEN,TFT_BLACK);
  M5.Lcd.setCursor(0,0); M5.Lcd.print("< Message Receiver 1.0 >");
  M5.Lcd.setCursor(0,20); M5.Lcd.print("ReceiverIP:"+lip);
  for (int i=0; i<lmsg; i++) {
    M5.Lcd.setCursor(0,20*i+60); M5.Lcd.print(msg[i]);
  }
}

void lScroll() {                           // スクロール
  if(lptr>lmsg-1){                         
    for (int i=0; i<lmsg-1; i++) {            
      msg[i]=msg[i+1];
    }
    lptr=lmsg-1;
  }  
}

void setup() {
  M5.begin();
  WiFi.mode(WIFI_STA);                    // 無線LANをSTAモードに設定
  WiFi.begin(SSID,PASS);                  // 無線LANアクセスポイントへ接続
  while(WiFi.status() != WL_CONNECTED){   // 接続に成功するまで待つ
    delay(500);                           // 待ち時間処理
  }
  lip=WiFi.localIP().toString();
  drawLcd();
  udp.begin(R_PORT);                      // UDP通信御開始
}

void loop() {                             // 繰り返し実行する関数
  char lcdp[20];                          // 表示用変数を定義(49バイト48文字)
  int len;                                // 文字列長を示す整数型変数を定義
  memset(lcdp, 0, 20);                    // 文字列変数lcdの初期化(49バイト)
  len = udp.parsePacket();                // 受信パケット長を変数lenに代入
  if(len==0)return;                       // 未受信のときはloop()の先頭に戻る
  udp.read(lcdp, 20);                     // 受信データを文字列変数lcdpへ代入
  lScroll();                              // スクロール
  msg[lptr++]=lcdp;
  drawLcd();
}
