#include <M5Stack.h>
#include <Wire.h>
#include <WiFi.h>
#include <WiFiUDP.h>
#define FACES_KEYBOARD_I2C_ADDR 0x08
#define SSID "**********"                     // 無線LANアクセスポイントのSSID
#define PASS "**********"                     // パスワード
static WiFiUDP udp; 
static const int rport = 9000; //送信先のポート
static const int lport = 7000;  //自身のポート
String str="";
String lip="192.168.64.xx";
String msg[]={"","","","","","",""};
int lmsg=7;
int lptr=0;
int rp[]={192,168,64,50};
String rip="";
char ripc[50];
int setM=0;

void drawLcd() {
  M5.Lcd.clear();
  M5.Lcd.setTextSize(2);
  M5.Lcd.setTextColor(TFT_YELLOW,TFT_BLACK);
  M5.Lcd.setCursor(0,0); M5.Lcd.print("< Message Sender 1.0 >");
  M5.Lcd.setCursor(0,20); M5.Lcd.print("Setting Mode:"+String(setM));
  rip=String(rp[0])+"."+String(rp[1])+"."+String(rp[2])+"."+String(rp[3]);
  M5.Lcd.setCursor(0,40); M5.Lcd.print("ReceiverIP:"+rip);
  M5.Lcd.setCursor(0,60); M5.Lcd.print("MySenderIP:"+lip);
  for (int i=0; i<lmsg; i++) {
    M5.Lcd.setCursor(0,20*i+100); M5.Lcd.print(msg[i]);
  }
}

void lScroll() {                           // スクロール
  if(lptr>lmsg-1){                         
    for (int i=0; i<lmsg-1; i++) {            
      msg[i]=msg[i+1];
    }
    lptr=lmsg-1;
  }  
}

void setup() {
  M5.begin();
  drawLcd();
  while(1){
    if(M5.BtnA.wasPressed()){
      ++setM; if (setM>4) setM=0;
      drawLcd();
    } else if (M5.BtnB.wasPressed() && setM<4 && rp[setM]>0 ){
      --rp[setM]; drawLcd();
    } else if (M5.BtnC.wasPressed() && setM<4 && rp[setM]<255){
      ++rp[setM]; drawLcd();
    } else if (setM==4 && (M5.BtnB.wasPressed() || M5.BtnC.wasPressed())){
      break;
    }
    M5.update();
    delay(100);
  }
  Wire.begin();
  WiFi.mode(WIFI_STA);                    // 無線LANをSTAモードに設定
  WiFi.begin(SSID,PASS);                  // 無線LANアクセスポイントへ接続
  while(WiFi.status() != WL_CONNECTED){   // 接続に成功するまで待つ
    delay(500);                        // 待ち時間処理
  }  
  udp.begin(rport);
  lip=WiFi.localIP().toString();
  drawLcd();
  rip.toCharArray(ripc,50);
  msg[lptr]="Connecting...";
  drawLcd();
  delay(500);
  msg[lptr]="Ready!";
  drawLcd();
  delay(1000);
  msg[lptr]=">";
  drawLcd();
}

void loop() {
  Wire.requestFrom(FACES_KEYBOARD_I2C_ADDR, 1);
  int c;
  while (Wire.available()) {
    c = Wire.read(); // receive a byte as character
    if (c>31  && c <128) {     
      str +=(char)c;
      msg[lptr]=">"+str;
      drawLcd();
    } else if (c==10) {
      udp.beginPacket(ripc,rport);  // 送信パケットの開始
      char buf[20];                       // 送信文字列配列bufの宣言
      char chr;
      memset(buf,0,20);                   // bufの全ての文字を0で初期化
      int len=str.length();               // 送信メッセージの文字数をlenに代入
      str.toCharArray(buf,20);            // 送信メッセージを配列bufに格納
      for (int i=0; i<len+1; i++) {
        chr=buf[i];
        udp.write(chr);                   // 送信メッセージを１文字ごとに送信
      }
      udp.endPacket();                    // 送信パケットの終了
      delay(300);
      lScroll();
      msg[lptr++]=">"+str;
      drawLcd();
      lScroll();
      str="";
      msg[lptr]=">";
      drawLcd();
    } else if (c==8){
      str=str.substring(0,str.length()-1);
      msg[lptr]=">"+str;
      drawLcd();
    }
    delay(300);
  }
}
